osg::ClipNode Class Reference

`#include <ClipNode>`

Inheritance diagram for osg::ClipNode:

## Public Types

enum | ReferenceFrame { RELATIVE_RF , ABSOLUTE_RF }
typedef std::vector< ref_ptr< ClipPlane > > | ClipPlaneList
Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| ClipNode ()
| ClipNode (const ClipNode &es, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, ClipNode)
void | setReferenceFrame (ReferenceFrame rf)
ReferenceFrame | getReferenceFrame () const
void | createClipBox (const BoundingBox &bb, unsigned int clipPlaneNumberBase=0)
bool | addClipPlane (ClipPlane *clipplane)
bool | removeClipPlane (ClipPlane *clipplane)
bool | removeClipPlane (unsigned int pos)
unsigned int | getNumClipPlanes () const
ClipPlane * | getClipPlane (unsigned int pos)
const ClipPlane * | getClipPlane (unsigned int pos) const
void | setClipPlaneList (const ClipPlaneList &cpl)
ClipPlaneList & | getClipPlaneList ()
const ClipPlaneList & | getClipPlaneList () const
void | setStateSetModes (StateSet &, StateAttribute::GLModeValue) const
void | setLocalStateSetModes (StateAttribute::GLModeValue=StateAttribute::ON)
virtual BoundingSphere | computeBound () const
Public Member Functions inherited from osg::Group
| Group ()
| Group (const Group &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Group)
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
virtual void | traverse (NodeVisitor &nv)
virtual bool | addChild (Node *child)
template<class T>
bool | addChild (const ref_ptr< T > &child)
virtual bool | insertChild (unsigned int index, Node *child)
template<class T>
bool | insertChild (unsigned int index, const ref_ptr< T > &child)
virtual bool | removeChild (Node *child)
template<class T>
bool | removeChild (const ref_ptr< T > &child)
bool | removeChild (unsigned int pos, unsigned int numChildrenToRemove=1)
virtual bool | removeChildren (unsigned int pos, unsigned int numChildrenToRemove)
virtual bool | replaceChild (Node *origChild, Node *newChild)
template<class T, class R>
bool | replaceChild (const ref_ptr< T > &origChild, const ref_ptr< R > &newChild)
virtual unsigned int | getNumChildren () const
virtual bool | setChild (unsigned int i, Node *node)
Node * | getChild (unsigned int i)
const Node * | getChild (unsigned int i) const
bool | containsNode (const Node *node) const
template<class T>
bool | containsNode (const ref_ptr< T > &node) const
unsigned int | getChildIndex (const Node *node) const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *=0) const
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | accept (NodeVisitor &nv)
virtual void | ascend (NodeVisitor &nv)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~ClipNode ()
Protected Member Functions inherited from osg::Group
virtual | ~Group ()
virtual void | childRemoved (unsigned int, unsigned int)
virtual void | childInserted (unsigned int)
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

StateAttribute::GLModeValue | _value
ClipPlaneList | _planes
ReferenceFrame | _referenceFrame
Protected Attributes inherited from osg::Group
NodeList | _children
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

Node for defining the position of ClipPlanes in the scene.

## Member Typedef Documentation

## ClipPlaneList

typedef std::vector<ref_ptr<ClipPlane> > osg::ClipNode::ClipPlaneList

## Member Enumeration Documentation

## ReferenceFrame

enum osg::ClipNode::ReferenceFrame

Enumerator
RELATIVE_RF |
ABSOLUTE_RF |

## Constructor & Destructor Documentation

## ClipNode() [1/2]

osg::ClipNode::ClipNode | ( |  | ) |

Referenced by ClipNode(), and META_Node().

## ClipNode() [2/2]

osg::ClipNode::ClipNode | ( | const ClipNode & | es,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

References ClipNode(), and osg::CopyOp::SHALLOW_COPY.

## ~ClipNode()

virtual osg::ClipNode::~ClipNode | ( |  | ) |

protected virtual

## Member Function Documentation

## addClipPlane()

bool osg::ClipNode::addClipPlane | ( | ClipPlane * | clipplane | ) |

Adds the clipplane. Returns true on success, and false if the plane has already been added, or if clipplane is NULL.

## computeBound()

virtual BoundingSphere osg::ClipNode::computeBound | ( |  | ) | const

virtual

Compute the bounding sphere around Node's geometry or children. This method is automatically called by getBound() when the bounding sphere has been marked dirty via dirtyBound().

Reimplemented from osg::Group.

## createClipBox()

void osg::ClipNode::createClipBox | ( | const BoundingBox & | bb,
|  | unsigned int | clipPlaneNumberBase = 0 )

Creates six clip planes corresponding to the given BoundingBox.

## getClipPlane() [1/2]

ClipPlane * osg::ClipNode::getClipPlane | ( | unsigned int | pos | ) |

inline

Get ClipPlane at the given index position.

References _planes.

## getClipPlane() [2/2]

const ClipPlane * osg::ClipNode::getClipPlane | ( | unsigned int | pos | ) | const

inline

Get const ClipPlane at the given index position.

References _planes.

## getClipPlaneList() [1/2]

ClipPlaneList & osg::ClipNode::getClipPlaneList | ( |  | ) |

inline

Get the ClipPlaneList.

References _planes.

## getClipPlaneList() [2/2]

const ClipPlaneList & osg::ClipNode::getClipPlaneList | ( |  | ) | const

inline

Get the const ClipPlaneList.

References _planes.

## getNumClipPlanes()

unsigned int osg::ClipNode::getNumClipPlanes | ( |  | ) | const

inline

Returns the number of ClipPlanes.

References _planes.

## getReferenceFrame()

ReferenceFrame osg::ClipNode::getReferenceFrame | ( |  | ) | const

inline

References _referenceFrame.

## META_Node()

osg::ClipNode::META_Node | ( | osg | ,
|  | ClipNode | )

References ClipNode().

## removeClipPlane() [1/2]

bool osg::ClipNode::removeClipPlane | ( | ClipPlane * | clipplane | ) |

Removes the clipplane. Returns true on success, false if clipplane isn't in this ClipNode.

## removeClipPlane() [2/2]

bool osg::ClipNode::removeClipPlane | ( | unsigned int | pos | ) |

Remove the ClipPlane with the given index. Returns true on success, false if pos is not a valid plane index.

## setClipPlaneList()

void osg::ClipNode::setClipPlaneList | ( | const ClipPlaneList & | cpl | ) |

inline

Set the ClipPlaneList.

References _planes.

## setLocalStateSetModes()

void osg::ClipNode::setLocalStateSetModes | ( | StateAttribute::GLModeValue | = StateAttribute::ON | ) |

Set up the local StateSet.

References osg::StateAttribute::ON.

## setReferenceFrame()

void osg::ClipNode::setReferenceFrame | ( | ReferenceFrame | rf | ) |

Set the ClipNode's ReferenceFrame, either to be relative to its parent reference frame, or relative to an absolute coordinate frame. RELATIVE_RF is the default. Note: setting the ReferenceFrame to be ABSOLUTE_RF will also set the CullingActive flag to false on the ClipNode (and consequently all of its parents), thereby disabling culling of it and all its parents. This is necessary to prevent inappropriate culling, but may impact cull times if the absolute ClipNode is deep in the scene graph. It is therefore recommended to only use absolute ClipNode at the top of the scene.

## setStateSetModes()

void osg::ClipNode::setStateSetModes | ( | StateSet & | ,
|  | StateAttribute::GLModeValue | ) const

Set the GLModes for all ClipPlanes, on the StateSet.

## Member Data Documentation

## _planes

ClipPlaneList osg::ClipNode::_planes

protected

Referenced by getClipPlane(), getClipPlane(), getClipPlaneList(), getClipPlaneList(), getNumClipPlanes(), and setClipPlaneList().

## _referenceFrame

ReferenceFrame osg::ClipNode::_referenceFrame

protected

Referenced by getReferenceFrame().

## _value

StateAttribute::GLModeValue osg::ClipNode::_value

protected

The documentation for this class was generated from the following file:

- ClipNode